"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _mocks = require("./mocks");

let currentModule;

const loadInRoll = mocks => {
  if (mocks.length) {
    currentModule = mocks[0];
    return Promise.resolve().then(currentModule.creator).then(() => loadInRoll(mocks.slice(1)));
  } else {
    return Promise.resolve();
  }
};

const probeAsyncModules = {
  hasAsyncModules() {
    const mocks = (0, _mocks.getAllAsyncMocks)();
    return mocks.length ? mocks : false;
  },

  load: Module => (request, parent) => {
    currentModule.loaded = true;
    const baseRequest = Module._resolveFilename(request, parent);
    currentModule.mock.name = baseRequest;
    (0, _mocks.insertMock)(baseRequest, currentModule.mock);
  },

  execute() {
    const mocks = (0, _mocks.getAllAsyncMocks)();
    return loadInRoll(mocks);
  }
};

exports.default = probeAsyncModules;