'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.PASS = exports.NO = exports.YES = exports.standardWipeCheck = undefined;

var _common = require('../_common');

const YES = 'yes';
const NO = 'no';
const PASS = true;

const onetoone = a => a;
const pass = () => PASS;

const createPlugin = plugin => {
    const result = Object.assign({
        fileNameTransformer: onetoone,
        wipeCheck: pass,
        shouldMock: pass
    }, plugin);
    return result;
};

const standardWipeCheck = (stubs, moduleName) => {
    if (_common.extensions.find(ext => stubs[moduleName + ext]) !== undefined) {
        return YES;
    }
};

exports.standardWipeCheck = standardWipeCheck;
exports.YES = YES;
exports.NO = NO;
exports.PASS = PASS;
exports.default = createPlugin;