'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _common = require('./_common');

var _common2 = _interopRequireDefault(_common);

var _module = require('../module');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const onEnable = ({ mock }) => {
  mock.usedAs = undefined;
};

const onDisable = ({ mock }) => {
  const name = mock.name;
  if (mock.flag_toBeUsed && !mock.usedAs) {
    if (!mock.wasRequired) {
      throw new Error(name + ' is set toBeUsed, but was unused');
    }

    const history = mock.rejected.map(({ parent, plugins }) => (0, _module.getModuleName)(parent) + '->' + plugins.join(','));

    throw new Error(name + ' is set toBeUsed, was requied, by rejected by plugins.\n' + history.join('\n'));
  }
};

const plugin = (0, _common2.default)({
  onDisable,
  onEnable,

  name: 'toBeUsed'
});

exports.default = plugin;