'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.configure = undefined;

var _aliases = require('./common/aliases');

var _common = require('./_common');

var _common2 = _interopRequireDefault(_common);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let settings = null;

const configure = fileName => {
    settings = (0, _aliases.readAliases)(fileName);
};

const fileNameTransformer = fileName => {
    if (!settings) {
        configure();
    }
    return (0, _aliases.processFile)(fileName, settings);
};

const wipeCheck = (stubs, moduleName) => (0, _common.standardWipeCheck)(stubs, moduleName);

exports.configure = configure;
exports.default = (0, _common2.default)({
    fileNameTransformer,
    wipeCheck,

    name: 'webpack-alias'
});