'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.wipe = undefined;

var _mocks = require('./mocks');

var _plugins = require('./plugins');

var _relative = require('./plugins/relative');

// which one?
const wipe = exports.wipe = typeof __webpack_require__ === 'function' ? require('wipe-webpack-cache') : require('wipe-node-cache');

const primaryResolver = (stubs, moduleName) => stubs[moduleName];

const resolver = (stubs, moduleName) => {
  // never wipe .node(native) module
  if (moduleName.indexOf('.node') > -1) {
    return false;
  }
  return 0 || (0, _plugins.shouldWipe)(stubs, moduleName) || primaryResolver(stubs, moduleName) || (0, _relative.relativeWipeCheck)(stubs, moduleName);
};

const wipeCache = (primaryCache = {}) => {
  wipe(primaryCache, primaryResolver);
  wipe((0, _mocks.getAllMocks)(), resolver);
};

exports.default = wipeCache;